import * as server from "@minecraft/server"

var lastBucketHold = {}
var lastBucketHold2 = {}
var holdingBottomless = {}
var holdingBottomless2 = {}
var usingBucket = {}
const world = server.world
const system = server.system





world.afterEvents.itemUseOn.subscribe(({itemStack,source})=>{
    if(itemStack.typeId===`minecraft:nether_star`){
        
        const {block} = source.getBlockFromViewDirection()
        const entity = block.dimension.getEntities({maxDistance:3,type:`minecraft:item`,closest:1,location: block.location})[0]
            
        if(entity){
                
                const {dimension,location} =entity
                const ie = entity.getComponent("item").itemStack
                
                if(ie.typeId.includes(`bucket`)){
                    
                    const {amount,typeId} = ie
                    entity.runCommand(`execute as @s at @s if ~ ~-1 ~ gold_block if ~1 ~ ~ gold_block if ~-1 ~ ~ gold_block if ~ ~ ~1 gold_block if ~ ~ ~-1 gold_block run tag @s add gvalid`).then(()=>{
                        if(entity.hasTag(`gvalid`)){

                            if(typeId===`minecraft:lava_bucket`){
                                entity.runCommand(`fill ~-1 ~-1 ~-1 ~1 ~ ~1 air [] replace gold_block`)
                                entity.kill()
                                const ni =  new server.ItemStack(`ax:bottomless_bucket_lava`)
                                dimension.spawnItem(ni,location)
                                dimension.spawnParticle(`ax:bottomless_bucket_creation`,location)
                                world.playSound(`random.totem`,location)
                                source.runCommand(`clear @s nether_star 0 1`)
                            }


                        }
                    })
                   
                    
                }
            }
                
        
     
       
    }
    if(itemStack.typeId.includes(`bottomless_bucket`) && !itemStack.typeId.includes(`milk`)){
        //system.runTimeout(()=>{
            const pEquipment = source.getComponent('equippable')
            const ni =  new server.ItemStack(itemStack.typeId)
            pEquipment.setEquipment(server.EquipmentSlot.Mainhand,ni)
            
        //},1)
    }
})

world.afterEvents.entityHitBlock.subscribe(({damagingEntity:source,hitBlock: block,blockFace})=>{
    const itemStack = source.getComponent('equippable').getEquipment(server.EquipmentSlot.Mainhand)

    if(itemStack?.typeId===`minecraft:nether_star`){
        //console.warn(`a`)

        let {location} = block
        //const {block} = source.getBlockFromViewDirection()
        console.warn(blockFace)
        if(blockFace===`Up`){
            location.y = location.y+1
        } else if(blockFace===`East`){
            location.x = location.x+1
        } else if(blockFace===`West`){
            location.x = location.x-1
        } else if(blockFace===`North`){
            location.z = location.z-1
        } else if(blockFace===`South`){
            location.z = location.z+1
        }
        let entity = undefined
        block.dimension.getEntities({maxDistance:1.25,type:`minecraft:item`,location}).forEach((e)=>{
            const ie = e.getComponent("item").itemStack
            if(ie.typeId.includes(`bucket`) && ie.typeId.includes(`minecraft`)){
                entity = e
                return
            }
        })
            
        if(entity){
                
                const {dimension,location} =entity
                const ie = entity.getComponent("item").itemStack
                
                if(ie.typeId.includes(`bucket`)){
                    
                    const {amount,typeId} = ie
                    entity.runCommand(`execute as @s at @s if block ~ ~-1 ~ gold_block if block ~1 ~ ~ gold_block if block ~-1 ~ ~ gold_block if block ~ ~ ~1 gold_block if block ~ ~ ~-1 gold_block run tag @s add gvalid`)
                 
                    system.runTimeout(()=>{
                        if(entity.hasTag(`gvalid`)){
                            
                            let itemId = ``
                            if(typeId===`minecraft:lava_bucket`){
                                itemId =`ax:bottomless_bucket_lava`
                            }

                            if(typeId===`minecraft:water_bucket`){
                                itemId = `ax:bottomless_bucket_water`
                            }

                            if(typeId===`minecraft:milk_bucket`){
                                itemId = `ax:bottomless_bucket_milk`
                                
                            }

                            if(typeId===`minecraft:powder_snow_bucket`){
                                itemId = `ax:bottomless_bucket_powder_snow`
                                
                                
                            }



                            if (itemId !== ``){
                                const ni =  new server.ItemStack(itemId)
                                const nItem = dimension.spawnItem(ni,location)
                                dimension.spawnParticle(`ax:bottomless_bucket_creation`,location)
                                world.playSound(`random.totem`,location)
                                source.runCommand(`clear @s[m=!c] nether_star 0 1`)
                                entity.runCommand(`fill ~-1 ~-1 ~-1 ~1 ~ ~1 air [] replace gold_block`)
                                entity.kill()
                                nItem.applyImpulse({x: 0, y:1, z:0})
                            }

                        }
                    },1)
                   
                    
                }
            }
                
        
     
       
    }
    
})

world.beforeEvents.playerBreakBlock.subscribe((data)=>{
    if(data.itemStack?.typeId === `minecraft:nether_star`){
        data.cancel = true
    }
})